from .event_handler import EventHandler
from .fsm_aware import FSMAware


class FSMAwareEventHandler(EventHandler, FSMAware):
    # pylint: disable=abstract-method
    """
    Abstract base class for EventHandlers which automatically
    keep track of the state of the TFW FSM.
    """
    def __init__(self, connector):
        EventHandler.__init__(self, connector)
        FSMAware.__init__(self)

    def _event_callback(self, message):
        self.process_message(message)

    def handle_fsm_step(self, message):
        self.handle_event(message, self.connector)
