from tfw.internals.networking import Intent

from .util import DummyConnector, simulate_event
from ..control_event_handler import ControlEventHandler


def test_receives_control_intent():
    eh = ControlEventHandler(DummyConnector())
    messages = []
    eh.handle_event = lambda msg, _: messages.append(msg)

    test_msg = {"key": "cica", "intent": Intent.CONTROL.value}
    simulate_event(eh, test_msg)
    assert messages[0] == test_msg


def test_no_intent_defaults_to_control():
    eh = ControlEventHandler(DummyConnector())
    messages = []
    eh.handle_event = lambda msg, _: messages.append(msg)

    test_msg = {"key": "cica"}
    simulate_event(eh, test_msg)
    assert messages[0] == test_msg


def test_ignores_event_intent():
    eh = ControlEventHandler(DummyConnector())
    messages = []
    eh.handle_event = lambda msg, _: messages.append(msg)

    simulate_event(eh, {"key": "cica", "intent": Intent.EVENT.value})
    assert not messages
